from otree.api import Bot, SubmissionMustFail

from . import pages
from .models import Constants
from unittest import TestCase

checker = TestCase()


class PlayerBot(Bot):
    def play_round(self):
        yield SubmissionMustFail(pages.Page1, {'max10': 11}, error_fields=['max10'])

        yield pages.Page1, {'max10': 0}

        # omit the required field
        yield SubmissionMustFail(
            pages.Page2, error_fields=('add100_1', 'add100_2', 'charABC')
        )

        # negative input is not allowed
        # field-specific validation gets run first, and all at once
        # even if some are done by Django and others are
        # custom validation
        # (test 1)
        yield SubmissionMustFail(
            pages.Page2,
            {'add100_1': -98, 'add100_2': 1},
            error_fields={'charABC', 'add100_1'},
        )

        # field-specific validation gets run all at once,
        # even if some are done by Django and others are
        # custom validation methods
        # (test 2)
        yield SubmissionMustFail(
            pages.Page2,
            {'add100_1': -98, 'add100_2': 1, 'charABC': 'DEF'},
            error_fields=['charABC', 'add100_1'],
        )

        yield SubmissionMustFail(
            pages.Page2,
            {'add100_1': 98, 'add100_2': 1, 'charABC': 'ABC'},
            error_fields=['__all__'],
        )

        yield pages.Page2, {'add100_1': 99, 'add100_2': 1, 'charABC': 'ABC'}
