from otree.api import (
    models,
    BaseConstants,
    BaseSubsession,
    BaseGroup,
    BasePlayer,
    Currency as c,
    widgets,
)
import django.forms.widgets as dj_widgets

doc = """
Test misc functionality of a 1-player game
"""


class Constants(BaseConstants):
    name_in_url = 'form_validation'
    players_per_group = None
    num_rounds = 1


class Subsession(BaseSubsession):
    pass


class Group(BaseGroup):

    # example field
    min_max = models.CurrencyField(
        doc="""
        Description of this field, for documentation
        """,
        min=1,
        max=1,
    )

    min_max_dynamic = models.CurrencyField()


# make sure that the choices on the global widget never get mutated
# encountered this bug on 2017-10-07
dynamic_choices_widget = widgets.RadioSelectHorizontal()
dynamic_min_max_widget = dj_widgets.NumberInput()


class Player(BasePlayer):

    blank = models.CharField(blank=True)

    add100_1 = models.PositiveIntegerField()
    add100_2 = models.PositiveIntegerField()

    even_int = models.PositiveIntegerField()

    dynamic_choices = models.CharField(widget=dynamic_choices_widget)

    blank_dynamic_choices = models.IntegerField(blank=True)

    choices_flat = models.CurrencyField(
        widget=widgets.RadioSelect, choices=[c(1), c(2)]
    )

    choices = models.IntegerField(
        # make a widget instance
        widget=widgets.RadioSelect(),
        choices=[[1, 'A'], [2, 'B']],
    )

    min_max_dynamic = models.CurrencyField(widget=dynamic_min_max_widget)
    min_max_blank = models.FloatField(blank=True, min=1, max=1)
    min_max_blank2 = models.FloatField(blank=True, min=1, max=1)

    equals_one = models.IntegerField(initial=1)
