from otree.api import BaseSubsession, BaseGroup, BasePlayer, BaseConstants, models
import itertools

doc = "Testing group_by_arrival_time_method()"


class Constants(BaseConstants):
    name_in_url = 'gbat_custom'
    players_per_group = None
    num_rounds = 2


class Subsession(BaseSubsession):
    def creating_session(self):
        types = itertools.cycle(['A', 'B'])
        for p in self.get_players():
            p.type = next(types)

    def group_by_arrival_time_method(self, waiting_players):
        a_players = [p for p in waiting_players if p.type == 'A']
        b_players = [p for p in waiting_players if p.type == 'B']

        new_group = a_players[:1] + b_players[:1]
        if len(new_group) == 2:
            return new_group


class Group(BaseGroup):
    pass


class Player(BasePlayer):
    type = models.CharField()
