from otree.api import Bot, SubmissionMustFail

from . import pages
from .models import Constants
from django.conf import settings
from collections import namedtuple

LocStrings = namedtuple(
    'LocStrings', ['next', 'yes', 'time_left', 'user_defined_string']
)


STRINGS = {
    'de': LocStrings(
        next='Weiter',
        yes='Ja',
        time_left='Verbleibende Zeit',
        user_defined_string='Fußball',
    ),
    'zh-hans': LocStrings(
        next='下一页',
        yes='是',
        time_left='时间',
        user_defined_string='足球',
    ),
}


class PlayerBot(Bot):
    def play_round(self):
        strings = STRINGS[settings.LANGUAGE_CODE]
        assert strings.next in self.html
        assert strings.yes in self.html
        assert strings.time_left in self.html
        assert strings.user_defined_string in self.html
        yield SubmissionMustFail(pages.Page1)
