from otree.currency import currency_range
from otree.currency import Currency, RealWorldCurrency
from otree.db import models
import otree.models
import otree.forms
from otree.api import widgets
from otree.api import BasePlayer



class Subsession(otree.models.BaseSubsession):
    pass


class SimpleModel(otree.models.BaseGroup):
    name = models.CharField()

    def name_choices(self):
        return [(self.name, self.name.upper())]


class SimplePlayer(otree.db.models.OTreeModel):
    name = otree.db.models.CharField(max_length=50, blank=True)
    age = otree.db.models.IntegerField(default=30, null=True, blank=True)


class FormFieldModel(otree.models.BaseGroup):
    null_boolean = models.BooleanField()
    boolean = models.BooleanField(default=False)
    char = models.CharField()
    decimal = models.DecimalField(max_digits=5, decimal_places=2)
    float = models.FloatField()
    integer = models.IntegerField()
    positive_integer = models.PositiveIntegerField()
    text = models.TextField()
    alt_text = models.TextField()
    currency = models.CurrencyField()
    currency_choice = models.CurrencyField(choices=[('0.01', '0.01'), ('1.20', '1.20')])

    sent_amount = models.CurrencyField(choices=currency_range(0, 0.75, 0.05))
    slider_widget = models.IntegerField(widget=widgets.Slider())


class CurrencyFieldTestModel(otree.db.models.OTreeModel):
    currency_with_default_value_zero = models.CurrencyField(initial=Currency(0), min=0)
