from django.core.management import call_command
from django.urls import reverse
from otree.models import Session
from .utils import TestCase
import splinter
from otree.session import create_session
from tests.admin_report_legacy.models import CUSTOM_VAR


class TestAdminReport(TestCase):
    def setUp(self):
        create_session('admin_report', num_participants=1)
        self.session = Session.objects.get()

    def test_load(self):
        browser = self.splinter_browser
        browser.login()
        browser.visit_reverse('AdminReport', args=[self.session.code])

        for substring in ['42', '43', 'round 2']:
            self.assertTrue(browser.is_text_present(substring))

        browser.fill('app_name', 'tests.admin_report_legacy')
        browser.fill('round_number', '1')
        button = browser.find_by_id('submit')
        # Interact with elements
        button.click()
        self.assertIn('round 1', browser.html)
        self.assertIn(CUSTOM_VAR, browser.html)
