from .utils import TestCase
from otree.extensions import (
    get_extensions_modules,
    get_extensions_data_export_views,
)
from tests.extensions_app.otree_extensions.admin import SomeView
import inspect
import tests.extensions_app.otree_extensions.admin as admin_module


class ExtensionTests(TestCase):
    def test_discovery(self):
        with self.settings(EXTENSION_APPS=['tests.extensions_app']):

            # module exists
            self.assertEqual(get_extensions_modules('admin'), [admin_module])

            # module doesn't exist, skip it
            self.assertEqual(get_extensions_modules('blah'), [])


    def test_data_export(self):
        with self.settings(EXTENSION_APPS=['tests.extensions_app']):
            views = get_extensions_data_export_views()
            self.assertEqual(views, [SomeView])
