import django.test.client
from .utils import TestCase
from django.urls import reverse

BOGUS_REQUEST_ID = 'bogus_request_id'


class TestPerfMiddleware(TestCase):
    def test_admin_basic(self):
        self.client.login()

        with self.assertLogs('otree.perf', level='INFO') as cm:
            self.client.get(reverse('DemoIndex'), HTTP_X_REQUEST_ID=BOGUS_REQUEST_ID)
            output = '\n'.join(cm.output)
            self.assertIn(BOGUS_REQUEST_ID, output)
            self.assertIn('own_time', output)
