from otree.models import Session, Participant
from .utils import TestCase
from otree.session import create_session
from tests.setattr import models, pages
from otree.views.abstract import ResponseForException
import numpy.random


class TestSetAttr(TestCase):
    def setUp(self):
        create_session('setattr', num_participants=1)
        self.session = Session.objects.get()

    def test_models(self):
        player = models.Player.objects.first()
        subsession = models.Subsession.objects.first()
        participant = Participant.objects.first()
        for obj in [player, subsession, participant]:
            with self.assertRaises(AttributeError):
                obj.nonexistent_variable = 1
        with self.assertRaises(TypeError):
            player.payoff = 'ten'
        player.f_bool = numpy.random.choice([True, False])

    def test_pages(self):
        participant = Participant.objects.first()
        # eventually replace this with assertRaises
        with self.assertRaises(ResponseForException):
            self.client.get(participant._start_url(), follow=True)
