from otree_startup import check_update_needed
from pathlib import Path

base_dir = Path('version_update')


def check(fn):
    return check_update_needed(base_dir / fn, current_version='3.3.0')


def test_ok():
    assert not check('ok.txt')


def test_nonexistent():
    assert not check('thisfiledoesnotexist.txt')


def test_ok_with_noise():
    assert not check('ok_with_noise.txt')


def test_need_newer():
    assert 'Enter: pip3 install "otree>=100"' in check('need_newer.txt')


def test_parse_error():
    assert not check('parse_error.txt')
