# -*- coding: utf-8 -*-

from otree.api import BaseSubsession, BaseGroup, BasePlayer, BaseConstants, models


doc = """
AAPA should be skipped if and only if all players skip the page.
"""


class Constants(BaseConstants):
    name_in_url = 'waitpage_skip_aapa'
    players_per_group = None
    num_rounds = 1


# use a global var because we don't have to think about model saving
WP_VISITS = set()


class Subsession(BaseSubsession):
    def creating_session(self):
        import sys
        sys.stdout.write('in creating_session\n')
        WP_VISITS.clear()


class Group(BaseGroup):
    aapa_executed = models.BooleanField(initial=False)

    def raise_error(self):
        1 / 0

    def mark_aapa_executed(self):
        self.aapa_executed = True


class Player(BasePlayer):
    pass
