# -*- coding: utf-8 -*-
from . import models
from otree.api import WaitPage
from tests.utils2 import BlankTemplatePage as Page
from .models import Constants, WP_VISITS


class WP(WaitPage):
    def is_displayed(self):
        return False

    after_all_players_arrive = 'raise_error'


class WP2(WaitPage):
    '''
    add this wait page to test the case where participants are waiting,
    but just on a different page. (bug discovered on 2020-10-10
    '''


class WP3(WaitPage):
    '''
    if a wait page is seen by 1 player, ensure AAPA is executed, even if the last player
    skips the page
    '''

    def is_displayed(self):
        # only the first player to arrive at the wait page sees it
        WP_VISITS.add(self.player.id_in_group)
        return WP_VISITS == set([self.player.id_in_group])

    after_all_players_arrive = 'mark_aapa_executed'


class Results(Page):
    def vars_for_template(self):
        assert self.group.aapa_executed


page_sequence = [WP, WP2, WP3, Results]
